/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.shop.srv.market.MarketManager
 *  fire.pb.shop.srv.market.jdbc.utils.handler.ResultSetHandler
 */
package fire.pb.shop.srv.market.jdbc;

import fire.pb.shop.srv.market.MarketManager;
import fire.pb.shop.srv.market.jdbc.ConnectionUtils;
import fire.pb.shop.srv.market.jdbc.Page;
import fire.pb.shop.srv.market.jdbc.utils.handler.ResultSetHandler;
import java.sql.Connection;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;

public class JdbcTemplate {
    private JdbcTemplate() {
    }

    public static JdbcTemplate getInstance() {
        return JdbcTemplateHolder.instance;
    }

    public ResultSet query(String sql) throws SQLException {
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        Connection conn = ConnectionUtils.getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = conn.createStatement(1004, 1007);
            rs = stmt.executeQuery(sql);
        }
        catch (SQLException e) {
            this.rethrow(e, sql, new Object[0]);
        }
        return rs;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public <T> T query(String sql, ResultSetHandler<T> rsh) throws SQLException {
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        if (rsh == null) {
            throw new SQLException("Null ResultSetHandler");
        }
        Connection conn = ConnectionUtils.getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        Object result = null;
        try {
            stmt = conn.createStatement(1004, 1007);
            rs = stmt.executeQuery(sql);
            result = rsh.handle(rs);
        }
        catch (SQLException e) {
            this.rethrow(e, sql, new Object[0]);
        }
        finally {
            if (rs != null) {
                rs.close();
            }
            if (stmt != null) {
                stmt.close();
            }
        }
        return (T)result;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public <T> T query(Page page, String sql, ResultSetHandler<T> rsh) throws SQLException {
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        if (rsh == null) {
            throw new SQLException("Null ResultSetHandler");
        }
        Connection conn = ConnectionUtils.getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        Object result = null;
        try {
            int row1;
            stmt = conn.createStatement(1004, 1007);
            stmt.setMaxRows(page.getEndIndex());
            rs = stmt.executeQuery(sql);
            if (page.getBeginIndex() > 0) {
                rs.absolute(page.getBeginIndex());
            }
            if ((row1 = page.getEndIndex() - page.getBeginIndex()) > 8) {
                MarketManager.LOG.error((Object)("翻页出现大于8条记录的查询" + row1));
            }
            result = rsh.handle(rs);
        }
        catch (SQLException e) {
            this.rethrow(e, sql, new Object[0]);
        }
        finally {
            if (rs != null) {
                rs.close();
            }
            if (stmt != null) {
                stmt.close();
            }
        }
        return (T)result;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public <T> T query(String sql, ResultSetHandler<T> rsh, Object ... params) throws SQLException {
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        if (rsh == null) {
            throw new SQLException("Null ResultSetHandler");
        }
        Connection conn = ConnectionUtils.getConnection();
        PreparedStatement stmt = null;
        ResultSet rs = null;
        Object result = null;
        try {
            stmt = conn.prepareStatement(sql);
            this.fillStatement(stmt, params);
            rs = stmt.executeQuery();
            result = rsh.handle(rs);
        }
        catch (SQLException e) {
            this.rethrow(e, sql, params);
        }
        finally {
            if (rs != null) {
                rs.close();
            }
            if (stmt != null) {
                stmt.close();
            }
        }
        return (T)result;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public int update(String sql) throws SQLException {
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        int rows = 0;
        try (Statement stmt = null;){
            stmt = ConnectionUtils.getConnection().createStatement();
            rows = stmt.executeUpdate(sql);
            if (MarketManager.LOG.isDebugEnabled()) {
                MarketManager.LOG.debug((Object)sql);
            }
        }
        return rows;
    }

    public int update(Connection conn, String sql) throws SQLException {
        return this.update(conn, sql, null);
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public int update(Connection conn, String sql, Object ... params) throws SQLException {
        if (conn == null) {
            throw new SQLException("Null connection");
        }
        if (sql == null) {
            throw new SQLException("Null SQL statement");
        }
        int rows = 0;
        try (PreparedStatement stmt = null;){
            stmt = conn.prepareStatement(sql);
            this.fillStatement(stmt, params);
            rows = stmt.executeUpdate();
            if (MarketManager.LOG.isDebugEnabled()) {
                MarketManager.LOG.debug((Object)sql);
            }
        }
        return rows;
    }

    public void fillStatement(PreparedStatement stmt, Object ... params) throws SQLException {
        int paramsCount;
        ParameterMetaData pmd = null;
        pmd = stmt.getParameterMetaData();
        int stmtCount = pmd.getParameterCount();
        int n = paramsCount = params == null ? 0 : params.length;
        if (stmtCount != paramsCount) {
            throw new SQLException("Wrong number of parameters: expected " + stmtCount + ", was given " + paramsCount);
        }
        if (params == null) {
            return;
        }
        for (int i = 0; i < params.length; ++i) {
            if (params[i] == null) continue;
            stmt.setObject(i + 1, params[i]);
        }
    }

    public void rethrow(SQLException cause, String sql, Object ... params) throws SQLException {
        String causeMessage = cause.getMessage();
        if (causeMessage == null) {
            causeMessage = "";
        }
        StringBuffer msg = new StringBuffer(causeMessage);
        msg.append(" Query: ");
        msg.append(sql);
        msg.append(" Parameters: ");
        if (params == null) {
            msg.append("[]");
        } else {
            msg.append(Arrays.deepToString(params));
        }
        SQLException e = new SQLException(msg.toString(), cause.getSQLState(), cause.getErrorCode());
        e.setNextException(cause);
        throw e;
    }

    private static class JdbcTemplateHolder {
        static JdbcTemplate instance = new JdbcTemplate();

        private JdbcTemplateHolder() {
        }
    }
}

